Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Minolta.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Minolta.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Minolta.pm	(revision 34921)
@@ -271,13 +531,41 @@
     45751 => '1.4x Teleconverter', #18
     45851 => 'Tamron SP AF 300mm F2.8 LD IF', #11
+    45861 => 'Tamron SP AF 35-105mm F2.8 LD Aspherical IF', #Fredrik Agert
+    45871 => 'Tamron AF 70-210mm F2.8 SP LD', #Fabio Suprani
+    # 48128: the Speed Booster Ultra appears to report type 48128 (=0xbc00)
+    # - this is the base to which the Canon LensType is added
+    48128 => 'Metabones Canon EF Speed Booster Ultra', #JR (to this, add Canon LensType)
+    # 61184: older firmware versions of both the Speed Booster and the Smart Adapter
+    # report type 61184 (=0xef00), and add only the lower byte of the Canon LensType (ref JR).
+    # For newer firmware versions this is only used by the Smart Adapter, and
+    # the full Canon LensType code is added - PH
+    # the metabones adapter translates Canon L -> G, II -> II, USM -> SSM, IS -> OSS (ref JR)
+    # This offset is used by Metabones, Fotodiox, Sigma MC-11 EF-E and Viltrox Canon EF adapters.
+    61184 => 'Canon EF Adapter', #JR (to this, add Canon LensType)
+    # 65280 = 0xff00
+    65280 => 'Sigma 16mm F2.8 Filtermatic Fisheye', #IB
     # all M42-type lenses give a value of 65535 (and FocalLength=0, FNumber=1)
-    65535 => 'T-Mount or Other Lens or no lens', #JD
-    65535.1 => 'Arax MC 35mm F2.8 Tilt+Shift', #JD
-    65535.2 => 'Arax MC 80mm F2.8 Tilt+Shift', #JD
-    65535.3 => 'Zenitar MF 16mm F2.8 Fisheye M42', #JD
-    65535.4 => 'Samyang 500mm Mirror F8.0', #19
-    65535.5 => 'Pentacon Auto 135mm F2.8', #19
-    65535.6 => 'Pentacon Auto 29mm F2.8', #19
-    65535.7 => 'Helios 44-2 58mm F2.0', #19
+    65535 => 'E-Mount, T-Mount, Other Lens or no lens', #JD/JR
+   '65535.1' => 'Arax MC 35mm F2.8 Tilt+Shift', #JD
+   '65535.2' => 'Arax MC 80mm F2.8 Tilt+Shift', #JD
+   '65535.3' => 'Zenitar MF 16mm F2.8 Fisheye M42', #JD
+   '65535.4' => 'Samyang 500mm Mirror F8.0', #19
+   '65535.5' => 'Pentacon Auto 135mm F2.8', #19
+   '65535.6' => 'Pentacon Auto 29mm F2.8', #19
+   '65535.7' => 'Helios 44-2 58mm F2.0', #19
+);
+
+%minoltaTeleconverters = (
+    0x00 => 'None',
+    0x04 => 'Minolta/Sony AF 1.4x APO (D) (0x04)', # (Andy Johnson, A77 APO and APO D)
+    0x05 => 'Minolta/Sony AF 2x APO (D) (0x05)', # (Andy Johnson, A77 APO D)
+    0x48 => 'Minolta/Sony AF 2x APO (D)',
+    # 0x48 => 'Sony 2x Teleconverter (SAL20TC)', (ref JR)
+    0x50 => 'Minolta AF 2x APO II',
+    0x60 => 'Minolta AF 2x APO',#26
+    0x88 => 'Minolta/Sony AF 1.4x APO (D)',
+    # 0x88 => 'Sony 1.4x Teleconverter (SAL14TC)', (ref JR)
+    0x90 => 'Minolta AF 1.4x APO II',
+    0xa0 => 'Minolta AF 1.4x APO',#26
 );
 
@@ -310,4 +598,13 @@
     7 => 'Adobe RGB',
     12 => 'Neutral', # Sony
+    13 => 'Clear', #JR (NC)
+    14 => 'Deep', #JR
+    15 => 'Light', #JR (NC)
+    16 => 'Autumn Leaves', #JR (NC)
+    17 => 'Sepia', #JR
+    18 => 'FL', #JR (7SM3)
+    19 => 'Vivid 2', #JR (7SM3)
+    20 => 'IN', #JR (7SM3)
+    21 => 'SH', #JR (7SM3)
     100 => 'Neutral', #JD
     101 => 'Clear', #JD
@@ -316,5 +613,6 @@
     104 => 'Night View', #JD
     105 => 'Autumn Leaves', #JD
-    0xffffffff => 'n/a', #PH
+    255 => 'Off', #JR (new for ILCE-7SM3, July 2020)
+   0xffffffff => 'n/a', #PH
 );
 
@@ -330,5 +628,5 @@
     8 => 'Macro',
     9 => 'Super Macro',
-    16 => 'Auto',
+    16 => 'Auto', # (RX100 'Intelligent Auto' - PH)
     17 => 'Night View/Portrait',
     18 => 'Sweep Panorama', #PH (SLT-A55V)
@@ -338,5 +636,27 @@
     22 => 'Auto+',
     23 => '3D Sweep Panorama', #PH (SLT-A55V)
+    24 => 'Superior Auto', #28
+    25 => 'High Sensitivity', #28
+    26 => 'Fireworks', #28
+    27 => 'Food', #28
+    28 => 'Pet', #28
+    33 => 'HDR', #JR
     0xffff => 'n/a', #PH
+);
+
+# tag information for AFStatus tags (ref 20)
+%afStatusInfo = (
+    Format => 'int16s',
+    # 0=in focus, -32768=out of focus, -ve=front focus, +ve=back focus
+    PrintConvColumns => 2,
+    PrintConv => {
+        0 => 'In Focus',
+        -32768 => 'Out of Focus',
+        OTHER => sub {
+            my ($val, $inv) = @_;
+            $inv and $val =~ /([-+]?\d+)/, return $1;
+            return $val < 0 ? "Front Focus ($val)" : "Back Focus (+$val)";
+        },
+    },
 );
 
@@ -403,15 +723,32 @@
         },
     },
+    0x0010 => { #20 (count: 256)
+        Name => 'CameraInfoA100',
+        Condition => '$$self{Model} eq "DSLR-A100"',
+        SubDirectory => {
+            TagTable => 'Image::ExifTool::Minolta::CameraInfoA100',
+            ByteOrder => 'LittleEndian',
+        },
+    },
     # it appears that image stabilization is on if this tag exists (ref 2),
     # but it is an 8kB binary data block!
-    0x0018 => {
-        Name => 'ImageStabilization',
-        Condition => '$self->{Model} =~ /^DiMAGE (A1|A2|X1)$/',
-        Notes => q{
-            a block of binary data which exists in DiMAGE A2 (and A1/X1?) images only if
-            image stabilization is enabled
-        },
-        ValueConv => '"On"',
-    },
+    0x0018 => [
+        {
+            Name => 'ISInfoA100',
+            Condition => '$self->{Model} eq "DSLR-A100"',
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Minolta::ISInfoA100',
+                ByteOrder => 'BigEndian',
+            },
+        },{
+            Name => 'ImageStabilization',
+            Condition => '$self->{Model} =~ /^DiMAGE (A1|A2|X1)$/',
+            Notes => q{
+                a block of binary data which exists in DiMAGE A2 (and A1/X1?) images only if
+                image stabilization is enabled
+            },
+            ValueConv => '"On"',
+        },
+    ],
     0x0020 => {
         Name => 'WBInfoA100',
@@ -430,4 +767,5 @@
         # JPEG preview found in DiMAGE 7 images
         %Image::ExifTool::previewImageTagInfo,
+        Groups => { 2 => 'Preview' },
         Permanent => 1,     # don't add this to a file
     },
@@ -438,4 +776,5 @@
         DataTag => 'PreviewImage',
         Writable => 'int32u',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
         # Note: Sony also uses this tag in A100 ARW images, but it points
@@ -447,4 +786,5 @@
         DataTag => 'PreviewImage',
         Writable => 'int32u',
+        WriteGroup => 'MakerNotes',
         Protected => 2,
     },
@@ -472,5 +812,5 @@
         Name => 'MinoltaQuality',
         Writable => 'int32u',
-        # PrintConv strings conform with Minolta reference manual (ref 4)
+        # PrintConv strings conform with Minolta reference manual (ref NJ)
         # (note that Minolta calls an uncompressed TIFF image "Super fine")
         PrintConv => {
@@ -492,5 +832,5 @@
             Notes => 'quality for DiMAGE A2/7Hi',
             Priority => 0, # lower priority because this doesn't work for A200
-            PrintConv => { #4
+            PrintConv => { #NJ
                 0 => 'Raw',
                 1 => 'Super Fine',
@@ -525,11 +865,5 @@
         Writable => 'int32u',
         PrintHex => 1,
-        PrintConv => {
-            0x00 => 'None',
-            0x48 => 'Minolta AF 2x APO (D)',
-            0x50 => 'Minolta AF 2x APO II',
-            0x88 => 'Minolta AF 1.4x APO (D)',
-            0x90 => 'Minolta AF 1.4x APO II',
-        },
+        PrintConv => \%minoltaTeleconverters,
     },
     0x0107 => { #8
@@ -563,4 +897,5 @@
         Writable => 'int32u',
         SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%minoltaLensTypes,
     },
@@ -646,5 +981,5 @@
         information may not be as reliable as it should be.  Because of this, tags
         in the following tables are set to lower priority to prevent them from
-        superceding the values of same-named tags in other locations when duplicate
+        superseding the values of same-named tags in other locations when duplicate
         tags are disabled.
     },
@@ -686,5 +1021,5 @@
     5 => {
         Name => 'MinoltaQuality',
-        PrintConv => { #4
+        PrintConv => { #NJ
             0 => 'Raw',
             1 => 'Super Fine',
@@ -1068,15 +1403,18 @@
     0x10 => {
         Name => 'AFPoints',
-        PrintConv => { BITMASK => {
-            0 => 'Center',
-            1 => 'Top',
-            2 => 'Top-Right',
-            3 => 'Right',
-            4 => 'Bottom-Right',
-            5 => 'Bottom',
-            6 => 'Bottom-Left',
-            7 => 'Left',
-            8 => 'Top-Left',
-        } },
+        PrintConv => {
+            0 => '(none)',
+            BITMASK => {
+                0 => 'Center',
+                1 => 'Top',
+                2 => 'Top-right',
+                3 => 'Right',
+                4 => 'Bottom-right',
+                5 => 'Bottom',
+                6 => 'Bottom-left',
+                7 => 'Left',
+                8 => 'Top-left',
+            },
+        },
     },
     0x15 => {
@@ -1408,4 +1746,120 @@
         Name => 'ImageStabilization',
         PrintConv => \%offOn,
+    },
+);
+
+# Camera settings used by the Sony DSLR-A100 (ref 20)
+%Image::ExifTool::Minolta::CameraInfoA100 = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    NOTES => 'Camera information for the Sony DSLR-A100.',
+    WRITABLE => 1,
+    PRIORITY => 0, # may not be as reliable as other information
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    FIRST_ENTRY => 0,
+    0x01 => { #PH
+        Name => 'AFSensorActive',
+        PrintConv => {
+            0 => 'Top-right',
+            1 => 'Bottom-right',
+            2 => 'Bottom',
+            3 => 'Middle Horizontal',
+            4 => 'Center Vertical',
+            5 => 'Top',
+            6 => 'Top-left',
+            7 => 'Bottom-left',
+        },
+    },
+    0x02 => {
+        Name => 'AFStatusActiveSensor',
+        %afStatusInfo,
+        Notes => q{
+            the focus status at shutter release.  May not reflect the status after
+            focusing if the image is focused then recomposed
+        },
+    },
+    0x04 => { Name => 'AFStatusTop-right',      %afStatusInfo },
+    0x06 => { Name => 'AFStatusBottom-right',   %afStatusInfo },
+    0x08 => { Name => 'AFStatusBottom',         %afStatusInfo },
+    0x0a => {
+        Name => 'AFStatusMiddleHorizontal',
+        %afStatusInfo,
+        Notes => q{
+            any of the three horizontal sensors at the middle of the focus frame: Left,
+            Center or Right
+        },
+    },
+    0x0c => { Name => 'AFStatusCenterVertical', %afStatusInfo },
+    0x0e => { Name => 'AFStatusTop',            %afStatusInfo },
+    0x10 => { Name => 'AFStatusTop-left',       %afStatusInfo },
+    0x12 => { Name => 'AFStatusBottom-left',    %afStatusInfo },
+    0x14 => {
+        Name => 'FocusLocked',
+        # (Focus can be locked in all modes other than Manual and Continuous,
+        # and the latter can be overridden by pushing the Spot AF button)
+        PrintConv => {
+            0 => 'Manual Focus',
+            4 => 'No',
+            16 => 'Continuous Focus',
+            64 => 'Yes',
+        },
+    },
+    0x15 => {
+        Name => 'AFPoint',
+        PrintConvColumns => 2,
+        PrintConv => {
+            0 => 'Auto',
+            1 => 'Center',
+            2 => 'Top',
+            3 => 'Top-right',
+            4 => 'Right',
+            5 => 'Bottom-right',
+            6 => 'Bottom',
+            7 => 'Bottom-left',
+            8 => 'Left',
+            9 => 'Top-left',
+        },
+    },
+    0x16 => {
+        Name => 'AFMode',
+        PrintConv => {
+            0 => 'DMF',
+            1 => 'AF-S',
+            2 => 'AF-C',
+            3 => 'AF-A',
+        },
+    },
+    0x2d => { Name => 'AFStatusLeft',            %afStatusInfo },
+    0x2f => { Name => 'AFStatusCenterHorizontal',%afStatusInfo },
+    0x31 => { Name => 'AFStatusRight',           %afStatusInfo },
+    0x33 => {
+        Name => 'AFAreaMode',
+        PrintConv => {
+            0 => 'Wide',
+            1 => 'Local',
+            2 => 'Spot',
+        },
+    },
+);
+
+# Image stabilization information used by the Sony DSLR-A100 (ref 20)
+%Image::ExifTool::Minolta::ISInfoA100 = (
+    PROCESS_PROC => \&Image::ExifTool::ProcessBinaryData,
+    WRITE_PROC => \&Image::ExifTool::WriteBinaryData,
+    CHECK_PROC => \&Image::ExifTool::CheckBinaryData,
+    NOTES => 'Image stabilization information for the Sony DSLR-A100.',
+    WRITABLE => 1,
+    PRIORITY => 0, # may not be as reliable as other information
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    FIRST_ENTRY => 0,
+    0 => {
+        Name => 'ImageStabilization',
+        Format => 'int16u',
+        PrintHex => 1,
+        PrintConv => {
+            0x0000 => 'Off',
+            0x2784 => 'On',
+        },
     },
 );
@@ -1452,23 +1906,23 @@
     },
     0x06 => { #20
-        Name => 'ManualExposureTime',
-        Notes => 'the most recent exposure time set manually by the user',
-        ValueConv => '$val ? 2 ** ((48-$val)/8) : $val',
-        ValueConvInv => '$val ? 48 - 8*log($val)/log(2) : $val',
+        Name => 'ShutterSpeedSetting',
+        Notes => 'used only in M and S exposure modes',
+        ValueConv => '$val ? 2 ** (6 - $val/8) : 0',
+        ValueConvInv => '$val ? int((6 - log($val) / log(2)) * 8 + 0.5) : 0',
         PrintConv => '$val ? Image::ExifTool::Exif::PrintExposureTime($val) : "Bulb"',
         PrintConvInv => 'lc($val) eq "bulb" ? 0 : Image::ExifTool::Exif::ConvertFraction($val)',
     },
     0x07 => { #20
-        Name => 'ManualFNumber',
-        Notes => 'the most recent aperture set manually by the user',
-        ValueConv => '2 ** (($val-8)/16)',
-        ValueConvInv => '8 + 16*log($val)/log(2)',
-        PrintConv => 'sprintf("%.1f",$val)',
+        Name => 'ApertureSetting',
+        Notes => 'used only in M and A exposure modes',
+        ValueConv => '2 ** (($val/8 - 1) / 2)',
+        ValueConvInv => 'int((log($val) * 2 / log(2) + 1) * 8 + 0.5)',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
         PrintConvInv => '$val',
     },
     0x08 => { #20
         Name => 'ExposureTime',
-        ValueConv => '$val ? 2 ** ((48-$val)/8) : $val',
-        ValueConvInv => '$val ? 48 - 8*log($val)/log(2) : $val',
+        ValueConv => '$val ? 2 ** (6 - $val/8) : 0',
+        ValueConvInv => '$val ? int((6 - log($val) / log(2)) * 8 + 0.5) : 0',
         PrintConv => '$val ? Image::ExifTool::Exif::PrintExposureTime($val) : "Bulb"',
         PrintConvInv => 'lc($val) eq "bulb" ? 0 : Image::ExifTool::Exif::ConvertFraction($val)',
@@ -1476,22 +1930,23 @@
     0x09 => { #15/20
         Name => 'FNumber',
-        ValueConv => '2 ** (($val / 8 - 1) / 2)',
-        ValueConvInv => '$val>0 ? (2*log($val)/log(2)+1) * 8 : undef',
-        PrintConv => 'sprintf("%.1f",$val)',
+        ValueConv => '2 ** (($val/8 - 1) / 2)',
+        ValueConvInv => 'int((log($val) * 2 / log(2) + 1) * 8 + 0.5)',
+        PrintConv => 'Image::ExifTool::Exif::PrintFNumber($val)',
         PrintConvInv => '$val',
     },
     0x0a => { #20
-        Name => 'DriveMode2',
-        PrintConv => {
-            0 => 'Self-timer 10 sec',
-            1 => 'Continuous',
-            4 => 'Self-timer 2 sec',
-            5 => 'Single Frame',
-            8 => 'White Balance Bracketing Low',
-            9 => 'White Balance Bracketing High',
-            770 => 'Single-frame Bracketing Low',
-            771 => 'Continous Bracketing Low',
-            1794 => 'Single-frame Bracketing High',
-            1795 => 'Continuous Bracketing High',
+        Name => 'DriveMode2', # (one of these is probably DriveModeSetting like Sony - PH)
+        PrintHex => 1,
+        PrintConv => {
+            0x000 => 'Self-timer 10 sec',
+            0x001 => 'Continuous',
+            0x302 => 'Single-frame Bracketing Low',
+            0x702 => 'Single-frame Bracketing High',
+            0x303 => 'Continous Bracketing Low',
+            0x703 => 'Continuous Bracketing High',
+            0x004 => 'Self-timer 2 sec',
+            0x005 => 'Single Frame',
+            0x008 => 'White Balance Bracketing Low',
+            0x009 => 'White Balance Bracketing High',
         },
     },
@@ -1522,15 +1977,16 @@
     },
     0x0d => { #20
-        Name => 'LocalAFAreaPoint',
+        Name => 'AFPointSelected', # (v8.88: renamed from LocalAFAreaPoint)
+        # (9-point centre-cross AF system, ref JR)
         PrintConv => {
             1 => 'Center',
             2 => 'Top',
-            3 => 'Top-Right',
+            3 => 'Top-right',
             4 => 'Right',
-            5 => 'Bottom-Right',
+            5 => 'Bottom-right',
             6 => 'Bottom',
-            7 => 'Bottom-Left',
+            7 => 'Bottom-left',
             8 => 'Left',
-            9 => 'Top-Left',
+            9 => 'Top-left',
         },
     },
@@ -1553,5 +2009,5 @@
     },
     0x10 => { #20
-        Name => 'FlashExposureCompSetting',
+        Name => 'FlashExposureCompSet',
         Description => 'Flash Exposure Comp. Setting',
         # (may differ from FlashExposureComp for flash bracketing shots)
@@ -1618,4 +2074,5 @@
         PrintConv => {
             0 => 'sRGB',
+            2 => 'B&W', #PH (A100)
             5 => 'Adobe RGB',
         },
@@ -1981,5 +2438,5 @@
     },
     0x60 => { #20
-        Name => 'BatteryLevel',
+        Name => 'BatteryState',
         PrintConv => {
             3 => 'Very Low',
@@ -2000,28 +2457,298 @@
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
     FIRST_ENTRY => 0,
-    0x96  => { Name => 'WB_RGBLevels',          Format => 'int16u[3]' },
-    0xae  => { Name => 'WB_GBRGLevels',         Format => 'int16u[4]' },
-    0x304 => { Name => 'WB_RBPresetFlash',      Format => 'int16u[2]' },
-    0x308 => { Name => 'WB_RBPresetCoolWhiteF', Format => 'int16u[2]' },
-    0x3e8 => { Name => 'WB_RBPresetTungsten',   Format => 'int16u[2]' },
-    0x3ec => { Name => 'WB_RBPresetDaylight',   Format => 'int16u[2]' },
-    0x3f0 => { Name => 'WB_RBPresetCloudy',     Format => 'int16u[2]' },
-    0x3f4 => { Name => 'WB_RBPresetFlash',      Format => 'int16u[2]' },
-    0x3fc => {
-        Name => 'WB_RedPresetsFluorescent',
+    PRIORITY => 0,
+    0x0e => {
+        Name => 'DriveMode',
+        PrintConv => {
+            0 => 'Self-timer 10 sec',
+            1 => 'Continuous',
+            2 => 'Single-frame Exposure Bracketing',
+            3 => 'Continuous Exposure Bracketing',
+            4 => 'Self-Timer 2 sec',
+            5 => 'Single Frame',
+            8 => 'White Balance Bracketing Low',
+            9 => 'White Balance Bracketing High',
+        },
+    },
+    0x10 => {
+        Name => 'Rotation',
+        PrintConv => {
+            0 => 'Horizontal (normal)',
+            1 => 'Rotate 270 CW',
+            2 => 'Rotate 90 CW',
+        },
+    },
+    0x14 => {
+        Name => 'ImageStabilizationSetting',
+        PrintConv => { 0 => 'Off', 1 => 'On' },
+    },
+    0x15 => {
+        Name => 'DynamicRangeOptimizerMode',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Standard',
+            2 => 'Advanced',
+        },
+    },
+    0x2a => {
+        Name => 'ExposureCompensationMode',
+        PrintConv => {
+            0 => 'Ambient and Flash',
+            1 => 'Ambient Only',
+        },
+    },
+    0x2b => 'WBBracketShotNumber',
+    0x2c => {
+        Name => 'WhiteBalanceBracketing',
+        PrintConv => {
+            0 => 'Off',
+            1 => 'Low',
+            2 => 'High',
+        },
+    },
+    0x2d => 'ExposureBracketShotNumber',
+    0x31 => {
+        Name => 'FlashFunction',
+        Format => 'int16u',
+        PrintHex => 1,
+        PrintConv => {
+            0x0000 => 'No flash',
+            0x0300 => 'Built-in flash',
+            # (the following refers to an external flash)
+            0x1205 => 'Manual',
+            0x120e => 'Strobe',
+            #0x122e => ?
+            0x128e => 'Fill flash, Pre-flash TTL',
+            0x12ae => 'Bounce flash',
+            0x140e => 'Rear sync, ADI',
+            0x148e => 'Fill flash, ADI',
+            0x1580 => 'Wireless',
+            # 0x17ae => ?
+            0x178e => 'HSS',
+        },
+    },
+    0x34 => {
+        Name => 'ExposureMode',
+        Format => 'int16u',
+        PrintHex => 1,
+        PrintConvColumns => 2,
+        PrintConv => {
+            0x0000 => 'Program',
+            0x0001 => 'Aperture Priority',
+            0x0002 => 'Shutter Priority',
+            0x0003 => 'Manual',
+            0x0004 => 'Auto',
+            0x0005 => 'Program Shift A',
+            0x0006 => 'Program Shift S',
+            0x1013 => 'Portrait',
+            0x1023 => 'Sports',
+            0x1033 => 'Sunset',
+            0x1043 => 'Night View/Portrait',
+            0x1053 => 'Landscape',
+            0x1083 => 'Macro',
+        },
+    },
+    0x36 => {
+        Name => 'ColorMode',
+        Format => 'int16u',
+        PrintConv => {
+            0x00 => 'Standard',
+            0x01 => 'Vivid',
+            0x02 => 'Portrait',
+            0x03 => 'Landscape',
+            0x04 => 'Sunset',
+            0x05 => 'Night View',
+            0x07 => 'B&W',
+            0x08 => 'Adobe RGB',
+        },
+    },
+    0x38 => {
+        Name => 'AverageLV',
+        Format => 'int16u',
+        Notes => 'arithmetic mean of the readings from the 40 honeycomb segments',
+        ValueConv => '($val-106)/8',
+        ValueConvInv => '$val * 8 + 106',
+    },
+    # 0x3a - int16u: Approx FocusDistance in metres (0x0f50=inf)
+    0x3c => {
+        Name => 'FrameNumber',
+        # Numbers > 1 appear in continuous and continuous bracketing drive modes,
+        # as well as WB bracketing.
+    },
+    0x96  => { Name => 'WB_RGBLevels',              Format => 'int16u[3]' },
+    0xae  => { Name => 'WB_GBRGLevels',             Format => 'int16u[4]' },
+    0xc0  => {
+        Name => 'WB_RedLevelsTungsten',
+        Notes => '7 values for adjustments of -3 through +3',
+        Format => 'int16u[7]',
+    },
+    0xce  => { Name => 'WB_BlueLevelsTungsten',     Format => 'int16u[7]' },
+    0xdc  => { Name => 'WB_RedLevelsDaylight',      Format => 'int16u[7]' },
+    0xea  => { Name => 'WB_BlueLevelsDaylight',     Format => 'int16u[7]' },
+    0xf8  => { Name => 'WB_RedLevelsCloudy',        Format => 'int16u[7]' },
+    0x106 => { Name => 'WB_BlueLevelsCloudy',       Format => 'int16u[7]' },
+    0x114 => { Name => 'WB_RedLevelsFlash',         Format => 'int16u[7]' },
+    0x122 => { Name => 'WB_BlueLevelsFlash',        Format => 'int16u[7]' },
+    0x14c => {
+        Name => 'WB_RedLevelsFluorescent',
         Format => 'int16u[7]',
         Notes => q{
-            white balance red presets for fluorescent -2 through +4.  -2=Fluorescent,
+            white balance red presets for fluorescent -2 through +4:  -2=Fluorescent,
             -1=WhiteFluorescent, 0=CoolWhiteFluorescent, +1=DayWhiteFluorescent and
             +3=DaylightFluorescent
         },
     },
-    0x40a => {
-        Name => 'WB_BluePresetsFluorescent',
-        Format => 'int16u[7]',
-        Notes => 'white balance blue presets for fluorescent -2 through +4',
-    },
-    0x418 => { Name => 'WB_RBPresetShade',                 Format => 'int16u[2]' },
-    0x424 => { Name => 'WB_RBPresetCustom',                Format => 'int16u[2]' },
+    0x15a => { Name => 'WB_BlueLevelsFluorescent',  Format => 'int16u[7]' },
+    0x168 => { Name => 'WB_RedLevelsShade',         Format => 'int16u[7]' },
+    0x176 => { Name => 'WB_BlueLevelsShade',        Format => 'int16u[7]' },
+    0x188 => { Name => 'WB_RedLevel6500K',          Format => 'int16u' },
+    0x18a => { Name => 'WB_BlueLevel6500K',         Format => 'int16u' },
+    0x18c => { Name => 'WB_RedLevelCustom',         Format => 'int16u' },
+    0x18e => { Name => 'WB_BlueLevelCustom',        Format => 'int16u' },
+    0x198 => { Name => 'WB_RedLevel3500K',          Format => 'int16u' },
+    0x19a => { Name => 'WB_BlueLevel3500K',         Format => 'int16u' },
+    0x1be => {
+        Name => 'WB_RedLevelsKelvin',
+        Format => 'int16u[75]',
+        Notes => 'values for 2500-9900 K, in increments of 100 K',
+    },
+    0x254 => { Name => 'WB_BlueLevelsKelvin',       Format => 'int16u[75]' },
+    0x304 => { Name => 'WB_RBLevelsFlash',          Format => 'int16u[2]' },
+    0x308 => { Name => 'WB_RBLevelsCoolWhiteF',     Format => 'int16u[2]' },
+    0x3e8 => { Name => 'WB_RBLevelsTungsten',       Format => 'int16u[2]' },
+    0x3ec => { Name => 'WB_RBLevelsDaylight',       Format => 'int16u[2]' },
+    0x3f0 => { Name => 'WB_RBLevelsCloudy',         Format => 'int16u[2]' },
+    0x3f4 => { Name => 'WB_RBLevelsFlash',          Format => 'int16u[2]' },
+    0x3fc => { Name => 'WB_RedLevelsFluorescent',   Format => 'int16u[7]' },
+    0x40a => { Name => 'WB_BlueLevelsFluorescent',  Format => 'int16u[7]' },
+    0x418 => { Name => 'WB_RBLevelsShade',          Format => 'int16u[2]' },
+    0x420 => { Name => 'WB_RBLevels6500K',          Format => 'int16u[2]' },
+    0x424 => { Name => 'WB_RBLevelsCustom',         Format => 'int16u[2]' },
+    0x430 => { Name => 'WB_RBLevels3500K',          Format => 'int16u[2]' },
+    0x528 => { Name => 'WB_RBLevelsDaylight',       Format => 'int16u[2]' },
+    0x546 => { Name => 'WB_RGBLevels',              Format => 'int16u[3]' },
+    0x628 => {
+        Name => 'AEMeteringSegments',
+        Format => 'int8u[40]',
+        Notes => q{
+            metering values from the 40 honeycomb segments, converted to LV.  The first
+            value is for the outer cell, then the values are given row by row, from top
+            to bottom, with each row scanned left-to-right.  The 21st value is the
+            middle cell, which gives the spot metering
+        },
+        ValueConv    => sub { join ' ', map( { ($_ - 106) / 8 } split(' ',$_[0]) ) },
+        ValueConvInv => sub { join ' ', map( { int($_ * 8 + 106.5) } split(' ',$_[0]) ) },
+    },
+    0x690 => {
+        Name => 'MeasuredLV',
+        Notes => 'measured light value based on MeteringMode',
+        ValueConv => '($val-106)/8',
+        ValueConvInv => '$val * 8 + 106',
+    },
+    0x691 => {
+        Name => 'BrightnessValue',
+        ValueConv => '($val-106)/8',
+        ValueConvInv => '$val * 8 + 106',
+    },
+    # 0x87f - int8u: 33mm Equivalent magnification (FocusDistance = (1.5 * $val + 1) * FocalLength) (255=inf)
+    0x104c => { # (9600 bytes: 4 sets of 40x30 int16u values in the range 0-8191)
+        Name => 'TiffMeteringImage',
+        Format => 'undef[9600]',
+        Notes => q{
+            13-bit RBGG (?) 40x30 pixels, presumably metering info, converted to a 16-bit
+            TIFF image;
+        },
+        ValueConv => sub {
+            my ($val, $et) = @_;
+            return undef unless length $val >= 9600;
+            return \ "Binary data 7404 bytes" unless $et->Options('Binary');
+            my @dat = unpack('n*', $val);  # for Big-endian
+            # TIFF header for a 16-bit RGB 10dpi 40x30 image
+            $val = Image::ExifTool::MakeTiffHeader(40,30,3,16,10);
+            # re-order data to RGB pixels
+            my ($i, @val);
+            for ($i=0; $i<40*30; ++$i) {
+                # data is 13-bit (max 8191), shift left to fill 16 bits
+                # (typically, this gives a very dark image since the data should
+                # really be anti-logged to convert from EV to perceived brightness)
+#                 push @val, $dat[$i]<<3, $dat[$i+2400]<<3, $dat[$i+1200]<<3;
+                push @val, int(5041.1*log($dat[$i]+1)/log(2)), int(5041.1*log($dat[$i+2400]+1)/log(2)), int(5041.1*log($dat[$i+1200]+1)/log(2));
+            }
+            $val .= pack('v*', @val);   # add TIFF strip data
+            return \$val;
+        },
+    },
+    0x49b8 => {
+        Name => 'ExposureTime',
+        ValueConv => '$val ? 2 ** (6 - $val/8) : 0',
+        ValueConvInv => '$val ? int((6 - log($val) / log(2)) * 8 + 0.5) : 0',
+        PrintConv => '$val ? Image::ExifTool::Exif::PrintExposureTime($val) : "Bulb"',
+        PrintConvInv => 'lc($val) eq "bulb" ? 0 : Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x49ba => {
+        Name => 'ISO',
+        ValueConv => '2 ** (($val-48)/8) * 100',
+        ValueConvInv => '48 + 8*log($val/100)/log(2)',
+        PrintConv => 'int($val + 0.5)',
+        PrintConvInv => '$val',
+    },
+    0x49bb => { # (https://exiftool.org/forum/index.php/topic,3688.0.html)
+        # if this value is the 35mm equivalent magnification, then the formula could
+        # be (1.5 * 2**($val/16-5)+1) * FocalLength, but this tends to underestimate
+        # distance by about 18% (ref 20) (255=inf)
+        Name => 'FocusDistance',
+        ValueConv => '2**(($val-126)/16)',
+        ValueConvInv => 'log($val)/log(2)*16+126',
+        PrintConv => '$val > 266 ? "inf" : sprintf("%.2f m", $val)',
+        PrintConvInv => '$val=~s/ ?m//; $val=~/inf/i ? 267 : $val',
+    },
+    0x49bd => {
+        Name => 'LensType',
+        Format => 'int16uRev',
+        SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
+        PrintConv => \%minoltaLensTypes,
+    },
+    0x49c0 => {
+        Name => 'ExposureCompensation', # (in exposure bracketing, this is the actual value used)
+        Format => 'int8s',
+        ValueConv => '$val / 8',
+        ValueConvInv => '$val * 8',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x49c1 => {
+        Name => 'FlashExposureComp',
+        Description => 'Flash Exposure Compensation',
+        Format => 'int8s',
+        ValueConv => '$val / 8',
+        ValueConvInv => '$val * 8',
+        PrintConv => '$val ? sprintf("%+.1f",$val) : 0',
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
+    },
+    0x49c2 => {
+        Name => 'ImageStabilization',
+        PrintConv => \%offOn,
+    },
+    0x49c3 => {
+        Name => 'BrightnessValue',
+        ValueConv => '($val-106)/8',
+        ValueConvInv => '$val * 8 + 106',
+    },
+    0x49c5 => {
+        Name => 'MaxAperture',
+        ValueConv => '2 ** (($val-8)/16)',
+        ValueConvInv => '8 + 16*log($val)/log(2)',
+        PrintConv => 'sprintf("%.1f",$val)',
+        PrintConvInv => '$val',
+    },
+    # 0x49c6 - gives focal length using same formula as 0x49bb
+    0x49c7 => {
+        Name => 'FNumber',
+        ValueConv => '2 ** (($val-8)/16)',
+        ValueConvInv => '8 + 16*log($val)/log(2)',
+        PrintConv => 'sprintf("%.1f",$val)',
+        PrintConvInv => '$val',
+    },
     0x49dc => {
         Name => 'InternalSerialNumber',
@@ -2166,5 +2893,5 @@
     unless (defined $printConv) {
         if ($val & 0xffff0000) {
-            # the A2 values can be shifted by += 3 settings, where
+            # the A2 values can be shifted by +- 3 settings, where
             # each setting adds or subtracts 0x0010000 (ref 2)
             my $type = ($val & 0xff000000) + 0x800000;
@@ -2202,5 +2929,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
